---
title: Firefox 58 for developers
slug: Mozilla/Firefox/Releases/58
tags:
  - '58'
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div>

<article class="text-content" id="wikiArticle">
<p class="summary">This article provides information about the changes in Firefox 58 that will affect developers. Firefox 58 was released on January 23, 2018.</p>

<article class="text-content" id="wikiArticle">
<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>The <a href="/en-US/docs/Tools/Page_Inspector/How_to/Edit_CSS_shapes">Shape Path Editor</a> has been enabled by default for shapes generated via {{cssxref("clip-path")}} ({{bug(1405339)}}).</li>
 <li>The <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> now has a button to <a href="/en-US/docs/Tools/Network_Monitor#Pausing_and_resume_network_traffic_recording">pause/play recording of network traffic</a> ({{bug(1005755)}}).</li>
 <li>In the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> the "Flash" filter button is no longer available, and Flash requests are included in the "Others" filter ({{bug(1413540)}}).</li>
 <li>The code for the old Responsive Design Mode (enabled by default pre-Firefox 52) has now been removed from the Devtools ({{bug(1305777)}}). See <a href="/en-US/docs/Tools/Responsive_Design_Mode">Responsive Design Mode</a> for information on the new tools.</li>
 <li>The option to view MDN docs from the CSS pane of the page inspector has been removed ({{bug(1382171)}}) (was disabled since 55, {{bug(1352801)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("@font-face/font-display", "font-display")}} descriptor is now available by default on all platforms ({{bug(1317445)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("Promise.prototype.finally()")}} method has been implemented ({{bug(1019116)}}).</li>
 <li>The {{jsxref("PluralRules", "Intl.PluralRules")}} object has been implemented ({{bug(1403318)}}).</li>
 <li>The {{jsxref("NumberFormat.formatToParts", "Intl.NumberFormat.prototype.formatToParts()")}} method has been implemented ({{bug(1403319)}}).</li>
 <li>The {{jsxref("DateTimeFormat", "Intl.DateTimeFormat")}} object now supports the <code>hourCycle</code> option and the <code>hc</code> language tag ({{bug(1386146)}}).</li>
 <li>The <a href="https://github.com/tc39/proposal-optional-catch-binding">optional catch binding proposal</a> has been implemented ({{bug(1380881)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The {{domxref("PerformanceNavigationTiming")}} API has been implemented ({{bug(1263722)}}).
  <ul>
   <li>Gecko has also been given a pref that can be used to disable the interface if required — <code>dom.enable_performance_navigation_timing</code>, defaulting to <code>true</code> ({{bug(1403926)}}).</li>
  </ul>
 </li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>Errors reported via error objects in certain APIs — for example in the <code>error</code> property of {{domxref("FileReader")}}, {{domxref("IDBRequest")}}, and {{domxref("IDBTransaction")}}, and when requests made via certain methods of {{domxref("RTCPeerConnection")}} are unsuccessful — are now represented by {{domxref("DOMException")}} instances. {{domxref("DOMError")}} is now deprecated, having been removed from the DOM4 spec ({{bug(1120178)}}).</li>
 <li>The {{domxref("PerformanceResourceTiming.workerStart")}} property is now supported ({{bug(1191943)}}).</li>
 <li>Budget-based background timeout throttling has been implemented — see <a href="/en-US/docs/Web/API/Page_Visibility_API#Policies_in_place_to_aid_background_page_performance">Policies in place to aid background page performance</a> for more details ({{bug(1377766)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<p><em>No changes.</em></p>

<h4 id="Media_and_WebRTC">Media and WebRTC</h4>

<ul>
 <li>The prefixed version of {{domxref("HTMLMediaElement.srcObject")}} has been removed; make sure code is updated to use the standard <code>srcObject</code> instead of <code>mozSrcObject</code> ({{bug(1183495)}}).</li>
 <li>Using {{domxref("MediaStream.addTrack()")}} to add tracks to a stream obtained using {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}, then attempting to record the resulting stream now works as expected. Previously, only the tracks originally included in the stream returned by <code>getUserMedia()</code> were being included in the recorded media ({{bug(1296531)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/WebVTT_API">WebVTT</a> {{domxref("VTTRegion")}} interface has always been created when interpreting WebVTT files, but the resulting regions were not previously utilized. Starting in Firefox 58, they are, if you enable the preference <code>media.webvtt.regions.enabled</code> by setting its value to <code>true</code>.</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>Support for prefixed WebGL extensions has been removed ({{bug(1403413)}}):
  <ul>
   <li>For <code>MOZ_WEBGL_compressed_texture_atc</code> use {{domxref("WEBGL_compressed_texture_atc")}} instead.</li>
   <li>For <code>MOZ_WEBGL_compressed_texture_pvrtc</code> use {{domxref("WEBGL_compressed_texture_pvrtc")}} instead.</li>
   <li>For <code>MOZ_WEBGL_compressed_texture_s3tc</code> use {{domxref("WEBGL_compressed_texture_s3tc")}} instead.</li>
   <li>For <code>MOZ_WEBGL_depth_texture</code> use {{domxref("WEBGL_depth_texture")}} instead.</li>
   <li>For <code>MOZ_WEBGL_lose_context</code> use {{domxref("WEBGL_lose_context")}} instead.</li>
  </ul>
 </li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li><code><a href="/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/frame-ancestors">frame-ancestors</a></code> is no longer ignored in {{httpheader("Content-Security-Policy-Report-Only")}} ({{bug(1380755)}}).</li>
 <li>Firefox now implements a TLS handshake timeout with a default value of 30 seconds. The timeout value can be varied by editing the <code>network.http.tls-handshake-timeout</code> pref in about:config ({{bug(1393691)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/worker-src">worker-src</a></code> CSP directive has been implemented ({{bug(1302667)}}).</li>
 <li>The <a href="/en-US/docs/Web/HTTP/Status/425">425: Too Early</a> status code and related {{httpheader("Early-Data")}} request header are now supported ({{bug(1406908)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<p><em>No changes.</em></p>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="Other">Other</h3>

<ul>
 <li>"Add to home screen" is now supported in Firefox for Android, part of the <a href="/en-US/Apps/Progressive">Progressive Web Apps</a> effort ({{bug(1212648)}}).</li>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a> now has a tiered compiler providing load time optimizations ({{bug(1277562)}}), and new streaming APIs — {{jsxref("WebAssembly.compileStreaming()")}} and {{jsxref("WebAssembly.installStreaming()")}} {{bug(1347644)}}.</li>
</ul>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="HTML_2">HTML</h3>

<ul>
 <li>You can no longer nest an {{htmlelement("a")}} element inside a {{htmlelement("map")}} element to create a hotspot region — an {{htmlelement("area")}} element needs to be used instead ({{bug(1317937)}}).</li>
</ul>

<h3 id="CSS_2">CSS</h3>

<ul>
 <li>The following proprietary Mozilla system metric pseudo-classes are no longer available to web content ({{bug(1396066)}}):
  <ul>
   <li>{{Cssxref(":-moz-system-metric(images-in-menus)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(mac-graphite-theme)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(scrollbar-end-backward)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(scrollbar-end-forward)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(scrollbar-start-backward)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(scrollbar-start-forward)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(scrollbar-thumb-proportional)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(touch-enabled)")}}</li>
   <li>{{Cssxref(":-moz-system-metric(windows-default-theme)")}}</li>
  </ul>
 </li>
 <li>The following proprietary Mozilla media features are no longer available to web content ({{bug(1396066)}}):
  <ul>
   <li><code>-moz-color-picker-available</code></li>
   <li><code>-moz-is-glyph</code></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-mac-graphite-theme"><code>-moz-mac-graphite-theme</code></a></li>
   <li><code>-moz-mac-yosemite-theme</code></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-os-version"><code>-moz-os-version</code></a></li>
   <li><code>-moz-overlay-scrollbars</code></li>
   <li><code>-moz-physical-home-button</code></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-scrollbar-end-backward"><code>-moz-scrollbar-end-backward</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-scrollbar-end-forward"><code>-moz-scrollbar-end-forward</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-scrollbar-start-backward"><code>-moz-scrollbar-start-backward</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-scrollbar-start-forward"><code>-moz-scrollbar-start-forward</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-scrollbar-thumb-proportional"><code>-moz-scrollbar-thumb-proportional</code></a></li>
   <li><code>-moz-swipe-animation-enabled</code></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-accent-color-in-titlebar"><code>-moz-windows-accent-color-in-titlebar</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-classic"><code>-moz-windows-classic</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-compositor"><code>-moz-windows-compositor</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-default-theme"><code>-moz-windows-default-theme</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-glass"><code>-moz-windows-glass</code></a></li>
   <li><a href="/en-US/docs/Web/CSS/@media/-moz-windows-theme"><code>-moz-windows-theme</code></a></li>
  </ul>
 </li>
 <li>The proprietary Mozilla <code>:-moz-styleeditor-transitioning</code> pseudo-class is no longer available to web content ({{bug(1396099)}}).</li>
</ul>

<h3 id="JavaScript_2">JavaScript</h3>

<ul>
 <li>The non-standard {{jsxref("Date.prototype.toLocaleFormat()")}} method has been removed ({{bug(818634)}}). See <a href="/en-US/docs/Web/JavaScript/Reference/Errors/Deprecated_toLocaleFormat">Warning: Date.prototype.toLocaleFormat is deprecated</a> for more information and migration help.</li>
 <li>The non-standard and deprecated {{jsxref("Object.prototype.watch()")}} and {{jsxref("Object.prototype.unwatch", "unwatch()")}} methods have been removed and will no longer work ({{bug(638054)}}). Consider using <a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Defining_getters_and_setters">setters and getters</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Proxy">proxies</a> instead.</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Deprecated_and_obsolete_features/The_legacy_Iterator_protocol">legacy Iterator protocol</a>, the <code><a href="/en-US/docs/Archive/Web/StopIteration">StopIteration</a></code> object, the <a href="/en-US/docs/Web/JavaScript/Reference/Statements/Legacy_generator_function">legacy generator functions</a> and the non-standard {{jsxref("Function.prototype.isGenerator()")}} method have been removed. Use the ES2015 <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">iteration protocols</a> and standards-compliant <a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators">iterators and generators</a> instead ({{bug(1083482)}}, {{bug(1413867)}}, {{bug(1119777)}}).</li>
 <li>The non-standard <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Array_comprehensions">Array comprehensions</a> and<a href="/en-US/docs/Web/JavaScript/Reference/Operators/Generator_comprehensions"> Generator comprehensions</a> have been removed ({{bug(1414340)}}).</li>
</ul>

<h3 id="APIs_2">APIs</h3>

<ul>
 <li>The proprietary <code>moz-blob</code> and <code>moz-chunked-text</code> values of the {{domxref("XMLHttpRequest.responseType")}} property were removed completely in Firefox 58 ({{bug(1397145)}}, {{bug(1397151)}}, {{bug(1120171)}}).</li>
 <li>The <code>dom.abortController.enabled</code> and <code>dom.abortController.fetch.enabled</code> prefs that controlled exposure of the <a href="/en-US/docs/Web/API/Fetch_API#Aborting_a_fetch">Abort API functionality</a> have now been removed, since those features are now enabled by default ({{bug(1402317)}}).</li>
 <li>The proprietary <code>mozSrcObject</code> property was removed in Firefox 58 ({{bug(1183495)}}). Use the standard {{domxref("HTMLMediaElement.srcObject")}} property instead.</li>
</ul>

<h3 id="SVG_2">SVG</h3>

<p><em>No changes.</em></p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings">browserSettings</a>

  <ul>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/webNotificationsDisabled">browserSettings.webNotificationsDisabled</a> has been implemented (bug 1364942)</li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData">browsingData</a>
  <ul>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData/removeLocalStorage">browsingData.localStorage</a> now supports deleting localStorage by host (bug 1388428)</li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/pkcs11">pkcs11</a> API to manage security devices (Bug 1357391)</li>
 <li>privacy
  <ul>
   <li>first party isolation can now be toggled though firstPartyIsolate (bug 1409045)</li>
   <li>resist fingerprinting pref can now be toggle through resistFingerprinting (bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1397611">1397611)</a></li>
  </ul>
 </li>
 <li>tabs
  <ul>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/discard">tabs.discard</a> has been implemented (Bug 1322485)</li>
   <li>isArticle, isInReaderMode properties of Tab implemented (Bug 1381992)</li>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/toggleReaderMode">toggleReaderMode</a>() method implemented (Bug 1381992)</li>
   <li>openInReaderMode option of tabs.created implemented (Bug 1408993)</li>
   <li>tabs.onUpdated now notifies when entering/exiting reader mode (Bug 1402921)</li>
  </ul>
 </li>
 <li>theme
  <ul>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/theme/getCurrent">getCurrent</a>() method to obtain current theme properties (Bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1349944">1349944</a>)</li>
   <li>onUpdated method to receive WebExtension theme updates (Bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1349944">1349944</a>)</li>
   <li>colors.bookmark_text now supported as alias of colors.toolbar_text (Bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1412595">1412595</a>)</li>
   <li>colors.toolbar_top_separator, colors.toolbar_bottom_separator and colors.toolbar_vertical_separator implemented (Bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1347190">1347190)</a></li>
  </ul>
 </li>
 <li>webRequest
  <ul>
   <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/webRequest/onBeforeRequest">webRequest.onBeforeRequest</a> now includes a "frameAncestors" parameter</li>
  </ul>
 </li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/58">Site Compatibility for Firefox 58</a></li>
</ul>
</article>

<ul>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(57)}}</p>
</article>
